#include "amxxmodule.h"
#include <curl\curl.h>
#include "CurlCleanerThread.h"
#include "curl_callbacks.h"

// amx_natives.cpp
extern AMX_NATIVE_INFO g_AmxCurlNatives[];
extern CCurlCleanerThread g_cctCleaner;

// amx_natives_open_ssl.cpp
extern AMX_NATIVE_INFO g_AmxOpenSSLNatives[];

void OnAmxxAttach() {
	curl_global_init(CURL_GLOBAL_ALL);

	if(!g_cctCleaner.Start()) {
		SERVER_PRINT("[CURL] (OnAmxxAttach) Can't start CCurlCleanerThread thread, natives would not be loaded. (   )\n");
		return;
	}

	CCB_InitializeCallbacksMap();

	MF_AddNatives(g_AmxCurlNatives);
	MF_AddNatives(g_AmxOpenSSLNatives);
}

void OnAmxxDetach() {
	ServerDeactivate();
	curl_global_cleanup();
}