#include "amxxmodule.h"
#include <curl\curl.h>

int MF_RegisterSPForwardByName_arr(AMX* amx, const char* func, const char* params, int count) {
	switch(count) {
	case 1: return MF_RegisterSPForwardByName(amx, func, params[0]);
	case 2: return MF_RegisterSPForwardByName(amx, func, params[0], params[1]);
	case 3: return MF_RegisterSPForwardByName(amx, func, params[0], params[1], params[2]);
	case 4: return MF_RegisterSPForwardByName(amx, func, params[0], params[1], params[2], params[3]);
	case 5: return MF_RegisterSPForwardByName(amx, func, params[0], params[1], params[2], params[3], params[4]);
	case 6: return MF_RegisterSPForwardByName(amx, func, params[0], params[1], params[2], params[3], params[4], params[5]);
	case 7: return MF_RegisterSPForwardByName(amx, func, params[0], params[1], params[2], params[3], params[4], params[5], params[6]);
	case 8: return MF_RegisterSPForwardByName(amx, func, params[0], params[1], params[2], params[3], params[4], params[5], params[6], params[7]);
	}

	MF_LogError(amx, AMX_ERR_NATIVE, "[MF_RegisterSPForwardByName_arr] invalid params count: %d (min: 1, max: 8)", count);

	return 0;
}

int MF_ExecuteForward_arr(AMX* amx, int callback, const cell* params, int count) {
	switch(count) {
	case 1: return MF_ExecuteForward(callback, params[0]);
	case 2: return MF_ExecuteForward(callback, params[0], params[1]);
	case 3: return MF_ExecuteForward(callback, params[0], params[1], params[2]);
	case 4: return MF_ExecuteForward(callback, params[0], params[1], params[2], params[3]);
	case 5: return MF_ExecuteForward(callback, params[0], params[1], params[2], params[3], params[4]);
	case 6: return MF_ExecuteForward(callback, params[0], params[1], params[2], params[3], params[4], params[5]);
	case 7: return MF_ExecuteForward(callback, params[0], params[1], params[2], params[3], params[4], params[5], params[6]);
	case 8: return MF_ExecuteForward(callback, params[0], params[1], params[2], params[3], params[4], params[5], params[6], params[7]);
	}
	
	MF_LogError(amx, AMX_ERR_NATIVE, "[MF_ExecuteForward_arr] invalid params count: %d (min: 1, max: 8)", count);

	return 0;
}

int GetAmxCallbackParams(CURLoption opt, char *params) { // params     6 
	switch(opt) {

	case CURLOPT_WRITEFUNCTION:
	case CURLOPT_READFUNCTION:
	case CURLOPT_HEADERFUNCTION:
		params[0] = FP_ARRAY;
		params[1] = FP_CELL;
		params[2] = FP_CELL;
		params[3] = FP_CELL;
		params[4] = FP_DONE;
		return 5;

	case CURLOPT_IOCTLFUNCTION:
	case CURLOPT_SEEKFUNCTION:
	case CURLOPT_SOCKOPTFUNCTION:
	case CURLOPT_OPENSOCKETFUNCTION:
	case CURLOPT_SSL_CTX_FUNCTION:
	case CURLOPT_CHUNK_BGN_FUNCTION:
		params[0] = FP_CELL;
		params[1] = FP_CELL;
		params[2] = FP_CELL;
		params[3] = FP_DONE;
		return 4;

	case CURLOPT_CLOSESOCKETFUNCTION:
		params[0] = FP_CELL;
		params[1] = FP_CELL;
		params[2] = FP_DONE;
		return 3;

	case CURLOPT_PROGRESSFUNCTION:
		params[0] = FP_CELL;
		params[1] = FP_FLOAT;
		params[2] = FP_FLOAT;
		params[3] = FP_FLOAT;
		params[4] = FP_FLOAT;
		params[5] = FP_DONE;
		return 6;

	case CURLOPT_XFERINFOFUNCTION:
		params[0] = FP_CELL;
		params[1] = FP_CELL;
		params[2] = FP_CELL;
		params[3] = FP_CELL;
		params[4] = FP_CELL;
		params[5] = FP_DONE;
		return 6;

	case CURLOPT_DEBUGFUNCTION:
		params[0] = FP_CELL;
		params[1] = FP_CELL;
		params[2] = FP_ARRAY;
		params[3] = FP_CELL;
		params[4] = FP_CELL;
		params[5] = FP_DONE;
		return 6;

	/*case CURLOPT_CONV_TO_NETWORK_FUNCTION:
	case CURLOPT_CONV_FROM_NETWORK_FUNCTION:
	case CURLOPT_CONV_FROM_UTF8_FUNCTION:
		params[0] = FP_ARRAY;
		params[1] = FP_CELL;
		params[2] = FP_DONE;
		return 3;*/

	case CURLOPT_INTERLEAVEFUNCTION:
		params[0] = FP_ARRAY;
		params[1] = FP_CELL;
		params[2] = FP_CELL;
		params[3] = FP_CELL;
		params[4] = FP_DONE;
		return 5;

	case CURLOPT_CHUNK_END_FUNCTION:
		params[0] = FP_CELL;
		params[1] = FP_DONE;
		return 2;

	case CURLOPT_FNMATCH_FUNCTION:
		params[0] = FP_CELL;
		params[1] = FP_STRING;
		params[2] = FP_STRING;
		params[3] = FP_DONE;
		return 4;
	}

	return 0;
}