#include <map>
#include <stack>
#include <curl\curl.h>
#include "amxxmodule.h"
#include "amx_utils.h"
#include "Thread.h"
#include "CurlCleanerThread.h"
#include "CurlThread.h"
#include "curl_callbacks.h"

using namespace std;

// amx_natives.cpp
extern map<CURL*, CCurlThread*> g_curlThreads;
extern CCurlCleanerThread g_cctCleaner;

void StartFrame_Post() {
	static stack<CURL*> to_remove;

	if(g_curlThreads.size() > 0 ) {
		for(map<CURL*, CCurlThread*>::iterator it = g_curlThreads.begin(); it != g_curlThreads.end(); ++it) {
			CCurlThread* cct = it->second;

			if(cct == NULL) {
				to_remove.push(it->first);
				continue;
			}

			cct->ExecuteNextAmxCallback();
		}

		while(!to_remove.empty()) {
			g_curlThreads.erase(to_remove.top());
			to_remove.pop();
		}
	}

	SET_META_RESULT(MRES_IGNORED);
}

void ServerDeactivate() {
	if(g_curlThreads.size() > 0 ) {
		for(map<CURL*, CCurlThread*>::iterator it = g_curlThreads.begin(); it != g_curlThreads.end(); ++it) {
			CCurlThread* cct = it->second;
			
			if(cct == NULL) {
				continue;
			}

			cct->SafeExit();
		}

		g_curlThreads.clear();
	}

	SET_META_RESULT(MRES_IGNORED);
}